﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.5
@EndOfDesignText@

Sub Class_Globals
	
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private fx As JFX
	
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView
	
	Private xBackground As Int
	Private xForeground As Int
	
	Private xPnl As B4XView
	Private lbTitle As Label
	Private b4xTitle As B4XView
	Private lbSideLbl As Label
	Private b4xSideLbl As B4XView
	Private lbUsrIcon1 As Label
	Private b4xUsrIcon1 As B4XView
	Private lbUsrIcon2 As Label
	Private b4xUsrIcon2 As B4XView
	Private lbMenuItem As Label
	Private b4xMenuItem As B4XView
	
	
	Private xSidePnl As B4XView
	Private wSidePnl As Int
	Private hSidePnl As Int
	Private xSideList As List



End Sub

'You can add more parameters here.
Public Sub Initialize (Callback As Object, EventName As String)
	Log("MarcMenu - Initialize:  EventName = " & EventName)
	
	mEventName = EventName
	mCallBack = Callback
	
	DesignerCreateView(mCallBack)
	


	#IF B4J
		
	#ELSE
	
	#END IF
	
End Sub


'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Log("MarcMenu - B4XPage_Created")
	'load the layout to Root
	'Root = Root1
End Sub

Public Sub DesignerCreateView (Base As Object)
	Log("DesignerCreateView")

	mBase = Base
	
	xPnl = xui.CreatePanel("xPnl")
	mBase.AddView(xPnl,0,0,mBase.Width,40dip)
	mBase.BringToFront
	
	
	


	' Title
	lbTitle.Initialize("lbTitle")
	b4xTitle = lbTitle
	b4xTitle.Font = fx.DefaultFont(20)
	b4xTitle.SetTextAlignment("CENTER","CENTER")
	xPnl.AddView(b4xTitle,0dip,0dip,xPnl.Width,40dip)
	
	'	Elipse for Side Menu
	lbSideLbl.Initialize("lbSideLbl")
	b4xSideLbl = lbSideLbl
	b4xSideLbl.Font = fx.CreateFontAwesome(22)
	b4xSideLbl.Text = Chr(0xF141)
	xPnl.AddView(b4xSideLbl,5dip,0dip,30dip,40dip)
	
	'	User Icon 1
	lbUsrIcon1.Initialize("lbUsrIcon1")
	b4xUsrIcon1 = lbUsrIcon1
	b4xUsrIcon1.SetTextAlignment("CENTER","CENTER")
	xPnl.AddView(b4xUsrIcon1, xPnl.Width - 30, 5dip, 30dip,40dip)
	
	'	User Icon 2
	lbUsrIcon2.Initialize("lbUsrIcon2")
	b4xUsrIcon2 = lbUsrIcon2
	b4xUsrIcon2.SetTextAlignment("CENTER","CENTER")
	xPnl.AddView(b4xUsrIcon2, xPnl.Width - 60, 5dip, 30dip,40dip)
	
End Sub

Private Sub lbSideLbl_MouseClicked(EventData As MouseEvent)
	Log("lbSideLbl_Mouse Clicked")
'	Dim lb As Label = Sender

	Log("Icon = " & Asc(lbSideLbl.Text))

	If Asc(lbSideLbl.Text) = 61761 Then	'	hamburger
		DisplaySideMenu
	Else
		'	put icon back and remove sidemenu
		xSidePnl.Visible = False
		b4xSideLbl.Text = Chr(61761)
		
	End If

End Sub

Private Sub lbUsrIcon1_MouseClicked(EventData As MouseEvent)
	Log("lbUsrIcon1_Mouse Clicked")

'	Dim lb As Label = Sender
'	b.Text = b.Text + 1

End Sub

Private Sub lbUsrIcon2_MouseClicked(EventData As MouseEvent)
	Log("lbUsrIcon2_Mouse Clicked")

'	Dim lb As Label = Sender
'	b.Text = b.Text + 1

End Sub

Private Sub DisplaySideMenu
	Log("DisplaySideMenu")
	
	b4xSideLbl.Text = Chr(0xF177)
	xSidePnl.Visible = True

End Sub

Private Sub lbMenuItem_Click	'	Not Working
	Log("lbMenuItemClick")
	
	
End Sub




Public Sub BandaidResize	'	SEE RESIZE EVENTS BELOW
	Log("BandaidResize")
	
	xPnl.Width = mBase.Width
	b4xTitle.SetLayoutAnimated(0,0,0,xPnl.Width, 40dip)
	b4xUsrIcon1.SetLayoutAnimated(0,xPnl.Width-30,0,30dip, 40dip)
	b4xUsrIcon2.SetLayoutAnimated(0,xPnl.Width-60,0,30dip, 40dip)
	
End Sub

'	FIND A SOLUTION FOR THIS NOT WORKING =========================================
Private Sub Base_Resize (Width As Int, Height As Int)
	Log("Base_Resize " & Width & " x " & Height)

End Sub

Private Sub mBase_Resize (Width As Int, Height As Int)
	Log("mBase_Resize " & Width & " x " & Height)

End Sub

Private Sub B4XPage_Resize (Width As Int, Height As Int)
	Log("B4XPage_Resize " & Width & " x " & Height)

End Sub

Private Sub MarcMenu_Resize (Width As Double, Height As Double)
	Log("MarcMenu_Resize " & Width & " x " & Height)
End Sub

Private Sub xPnl_Resize (Width As Double, Height As Double)	'	WORKS!
	Log("xPnl_Resize " & Width & " x " & Height)
End Sub
'	==============================================================================



'=====================================================================================================
'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.
'=====================================================================================================

Public Sub SetMenuColors(Background As Int, Foreground As Int)
	Log("SetMenuColors")
	
	xBackground = Background
	xForeground = Foreground
	
	xPnl.SetColorAndBorder(xBackground,0,xui.Color_Transparent,0)
	b4xTitle.TextColor = Foreground
	b4xSideLbl.TextColor = Foreground
	b4xUsrIcon1.TextColor = Foreground
	b4xUsrIcon2.TextColor = Foreground
	
End Sub

Public Sub SetTitle(inTitle As String)
	Log("SetTitle")
	b4xTitle.Text = inTitle
End Sub

Public Sub SetUsrIcon1(inText As String, inFont As B4XFont)
	Log("SetUsrIcon1")
	b4xUsrIcon1.Text = inText
	b4xUsrIcon1.Font = inFont
End Sub

Public Sub SetUsrIcon2(inText As String, inFont As B4XFont)
	Log("SetUsrIcon2")
	b4xUsrIcon2.Text = inText
	b4xUsrIcon2.Font = inFont
End Sub

Public Sub SetSideMenu(MenuList As List)
	Log("SetSideMenu")

	xSideList = MenuList

	If MenuList.Size = 0 Then
		Log("SetSideMenu:  Zero-length List")
		Return
	End If
	
	wSidePnl = 0
	hSidePnl = 0
	
	Dim qMap As Map
	qMap.Initialize

	hSidePnl = MenuList.Size
		
	For i = 0 To MenuList.Size - 1
		
		qMap = MenuList.Get(i)
		Log("Menu text is " & qMap.Get("MenuText"))
		Dim tx As String = qMap.Get("MenuText")
		If tx.Length > wSidePnl Then
			wSidePnl = tx.Length
		End If
		
	Next
	
	wSidePnl = wSidePnl * 20dip
	hSidePnl = hSidePnl * 40dip
	
	''Log("Width = " & wSidePnl & "  Height = " & hSidePnl)
	
	xSidePnl = xui.CreatePanel("xSidePnl")
	mBase.AddView(xSidePnl,0,40dip,wSidePnl,hSidePnl)
	
	xSidePnl.SetColorAndBorder(xBackground,0,xui.Color_Transparent,0)
	
	'	Load Side Menu ------------------------------------
	For i = 0 To xSideList.Size - 1
		
		qMap = xSideList.Get(i)
		Dim tx As String = qMap.Get("MenuText")
		
		lbMenuItem.Initialize("lbMenuItem")
		b4xMenuItem = lbMenuItem
		b4xMenuItem.Tag = i
		b4xMenuItem.Text = tx
		b4xMenuItem.Font = fx.DefaultFont(20)
		b4xMenuItem.TextColor = xForeground
		b4xMenuItem.SetTextAlignment( "CENTER","LEFT")
		xSidePnl.AddView(b4xMenuItem,10dip, i * 40dip, xSidePnl.Width + 20dip, 40dip)
		
		Private cvs As B4XCanvas
		cvs.Initialize(xSidePnl)
		Dim tHeight As Int = (i * 40dip)
		cvs.DrawLine(0, tHeight, wSidePnl, tHeight, xForeground, 1dip)
		
		xSidePnl.Visible = False
		
	Next
	
End Sub





